/*
Gemma's Battle Abilities

Original Programming by SMS Alfredo
Extra Programming by reverbal & JABsphere
*/

/*
Futureproofing for v2.2.11 (Cause Uncapped do be spewing ye the 
"P_TeleportMove is deprecated" warning into your face) (Also thanks Lach)
*/
local P_MoveOrigin = P_MoveOrigin or P_TeleportMove
local P_SetOrigin = P_SetOrigin or P_TeleportMove

freeslot("MT_GEMMAWALL", "SPR_EWAL", "MT_GEMMADIRT", "S_GEMMAPILLAR")

mobjinfo[MT_GEMMAWALL] = {
	spawnstate = S_INVISIBLE,
	painstate = S_INVISIBLE,
	spawnhealth = 3,
	seesound = sfx_s3kccs,
	painsound = sfx_cdfm32,
	deathsound = sfx_s1b9,
	radius = 64*FRACUNIT,
	height = 132*FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_SCENERY|MF_SLIDEME
}

mobjinfo[MT_GEMMADIRT] = {
	spawnstate = S_MINUSDIRT1,
	painstate = S_GEMMAPILLAR,
	painsound = sfx_s3k9b,
	deathsound = sfx_cdfm32,
	radius = 16*FRACUNIT,
	height = 42*FRACUNIT, //64
	flags = MF_NOBLOCKMAP|MF_SCENERY|MF_MISSILE
}

states[S_GEMMAPILLAR] = {SPR_EWAL, G, TICRATE*2, A_Pain, 0,  0, S_NULL}

local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or (ScriptLoaded) then return end
	ScriptLoaded = true
	local B = CBW_Battle
	
	local function GarbagePriority7(player)
		-- rev: avoid warnings...
		if 	(not player.mo)
			or (player.gemmasmash == nil) // we check for nil bacause sometimes its equal to 0 --JABsphere
			or (player.gemmaspindash == nil)
		then return end

		if player.gemmasmash == 1 and not P_IsObjectOnGround(player.mo) and player.cmd.buttons&BT_JUMP then //hit ground do rock platform
			B.SetPriority(player,1,1,"fang_tailbounce",1,2,"ground pound")
			
		elseif player.gemmasmash == 1 and not P_IsObjectOnGround(player.mo) then // bounces on the ground no rock platform
			B.SetPriority(player,1,1,"fang_tailbounce",2,1,"earth strike")
			
		elseif player.gemmasmash > 1 and not P_IsObjectOnGround(player.mo) then
			B.SetPriority(player,0,0,"fang_tailbounce",0,0,"rock platform")
			
		elseif player.actionstate == 3 and not P_IsObjectOnGround(player.mo) then
			B.SetPriority(player,1,1,"fang_tailbounce",3,3,"charged earth strike") 
			
		elseif player.gemmaspindash then
			B.SetPriority(player,1,1,"fang_tailbounce",1,1,"platform spindash") 
			
		end
	end
	
	//Ability
	local function GemmaBattle(mo,doaction)
		local player = mo.player
		
		-- rev: Actionstates. (yes, they were ripped directly from Lib_EnergyAttack
		local threshold1 = 6
		local threshold2 = threshold1+25
		local threshold3 = threshold2+20
		
		local state_charging = 12
		local attackready = (player.actiontime >= threshold1 and player.actionstate == state_charging)
		local charging = player.exhaustmeter and ((B.PlayerButtonPressed(player,player.battleconfig_special,true) or not(attackready)) and player.actionstate == state_charging)
	
		local state_placing = -22
		local state_placed = -21
		local wallready = (player.actionstate == state_placing)
		local wallplace = (wallready and doaction == 0)
		local wallplacing = (wallready and B.PlayerButtonPressed(player,player.battleconfig_special,true)) --(player.actionstate == state_placing)
		local cancelwall = (wallready and doaction == 2 and (B.PlayerButtonPressed(player,BT_TOSSFLAG,false) or B.PlayerButtonPressed(player,player.battleconfig_guard,false)))
	
		local rolltrigger = attackready and B.PlayerButtonPressed(player,BT_SPIN,false)
		local rockwave = not(rolltrigger) and attackready and doaction == 0 and attackready
		local chargehold = (attackready and B.PlayerButtonPressed(player,player.battleconfig_special,true))
		local idletrigger = not(rolltrigger) and attackready and doaction == 2 and B.PlayerButtonPressed(player,BT_TOSSFLAG,false)
		local canceltrigger =
			not(rockwave or rolltrigger or idletrigger)
			and player.actionstate == state_charging
			and doaction == 2
			and (
				player.exhaustmeter == 0
				or B.PlayerButtonPressed(player,player.battleconfig_guard,false)
			)
		
		if player.gemmarockwall
			if player.gemmarockwall.valid and player.gemmarockwall.health
			and player.gemmarockwall.type == MT_GEMMAWALL
				player.gemmarockwall.target = mo
				player.action2text = "\x80".."Wall HP \x83"..player.gemmarockwall.health.."/3"
				
				if not P_IsObjectOnGround(mo) or player.actionstate
					player.actiontext = "Rock Wave"
					player.actionrings = 10
				else
					player.actiontext = "Destroy wall"
					player.actionrings = 0
				end
			else
				player.gemmarockwall = nil
				S_StartSound(mo, sfx_jshard, player)
				B.ApplyCooldown(player,TICRATE*3)
			end
		elseif P_IsObjectOnGround(mo) and not player.actionstate
			player.actiontext = "Earth Wall"
			player.actionrings = 10
		else
			player.actiontext = "Rock Wave"
			player.actionrings = 10
		end
		player.action2rings = 0
		
		if not(B.CanDoAction(player)) or P_IsObjectInGoop(mo)
			player.actionstate = 0 --Default action state
		return end
		
		-- Intercepted while charging
		if (player.actionstate == state_charging) and player.powers[pw_nocontrol] then
			player.actionstate = 0
			player.actiontime = 0
			B.ApplyCooldown(player,cooldown_cancel)
			return
		end
		
		-- Wall
		if player.actionstate == state_placing then
			player.actiontext = "Earth Wall"
			player.action2text = "Cancel"
			player.pflags = $|PF_JUMPSTASIS
			
			local function drawLine(mo, color, pos)
					local dist = (mo.scale)*pos.x
					local dist2 = (mo.scale)*pos.y
					local angle = mo.angle+ANGLE_90
					
					-- starting offset
					local x1 = mo.x + FixedMul(dist, cos(angle))
					local y1 = mo.y + FixedMul(dist, sin(angle))

					-- offset to the side of (x1, y1)
					local xoffs = x1 + FixedMul(dist2, cos(angle-ANGLE_90))
					local yoffs = y1 + FixedMul(dist2, sin(angle-ANGLE_90))
					local zoffs = (mo.z+pos.z*FRACUNIT) - (mobjinfo[MT_THOK].height/3)

					local thokmobj = P_SpawnMobj( --P_SpawnMobjFromMobj(mo, 
						xoffs, 
						yoffs, 
						zoffs,--zoffs+z_teleoff,
					MT_THOK)
					
					local oldheight = thokmobj.height
					thokmobj.frame = $|FF_FULLBRIGHT--|FF_PAPERSPRITE
					thokmobj.scale = mo.scale/2
					thokmobj.color = color
					thokmobj.fuse = 1
					thokmobj.angle = mo.angle
					thokmobj.fuse = 1
					
					if consoleplayer ~= player then thokmobj.flags2 = $|MF2_DONTDRAW end
					if P_MobjFlip(mo) == -1 thokmobj.z = $-(thokmobj.height-oldheight) end
					thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING
			end
			
			-- NOTE: this is only an estimation of the real range of the wall, it's not precise!
			local function drawCube(mo, color)
				local x = (mobjinfo[MT_GEMMAWALL].radius/FRACUNIT)
				local y = (x*2)
				local z = x/3
				local height = mobjinfo[MT_GEMMAWALL].height/FRACUNIT
				
				-- mr. inefficient 2
				-- Ground hologram
				for i=-y, y, 16    do drawLine(mo, color, {x=i,y=y,z=z}) end
				for i=y, -y, -16   do drawLine(mo, color, {x=i,y=z,z=z}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=y,y=x+i,z=z}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=-y,y=x+i,z=z}) end
				
				-- Air hologram
				for i=-y, y, 16    do drawLine(mo, color, {x=i,y=y,z=height}) end
				for i=y, -y, -16   do drawLine(mo, color, {x=i,y=z,z=height}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=y,y=x+i,z=height}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=-y,y=x+i,z=height}) end
				
				-- Edge columns
				for i=z, x*2, 16  do drawLine(mo, color, {x=y,y=y,z=i}) end
				for i=z, x*2, 16  do drawLine(mo, color, {x=y,y=z,z=i}) end
				for i=z, x*2, 16  do drawLine(mo, color, {x=-y,y=y,z=i}) end
				for i=z, x*2, 16  do drawLine(mo, color, {x=-y,y=z,z=i}) end

			end
			
			-- todo: add scale parameter?
			local function checkRange()			
				local thokmobj = P_SpawnMobjFromMobj(mo, 
					FixedMul(128*cos(mo.angle), mo.scale), 
					FixedMul(128*sin(mo.angle), mo.scale), 
					0,--mo.z + mo.height, 
				MT_THOK)
				thokmobj.fuse = 1
							
				local oldheight = thokmobj.height
				thokmobj.radius = FixedMul(mobjinfo[MT_GEMMAWALL].radius*2, mo.scale)
				thokmobj.height = FixedMul(mobjinfo[MT_GEMMAWALL].height, mo.scale)
				thokmobj.flags2 = $|MF2_DONTDRAW
							
				if P_MobjFlip(mo) == -1 thokmobj.z = $-(thokmobj.height-oldheight) end
				thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				
				if P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
					mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
					and thokmobj.z - thokmobj.scale*8 <= mo.z + mo.height
					and thokmobj.z + thokmobj.height + thokmobj.scale*8 >= mo.z
				then
					local foundmobj = 0
					
					-- rev: 
					-- @refmobj: thok obj 
					-- @mobj: a mobj hindering us from placing a wall
					searchBlockmap("objects", function(refmobj, mobj)
						if 	not (mobj and mobj.valid and mobj.health and mobj != mo and mobj.flags&(MF_SHOOTABLE|MF_SOLID)) or 
							R_PointToDist2(refmobj.x, refmobj.y, mobj.x, mobj.y) > refmobj.radius + mobj.radius or 
							refmobj.z - refmobj.scale > mobj.z + mobj.height or 
							refmobj.z + refmobj.height + refmobj.scale < mobj.z or
							(mobj and mobj.player and mobj.player.spectator)  -- ignore flickies/spectators
						then
							return
						end
						foundmobj = mobj
					end, thokmobj)	
					
					if foundmobj or abs((thokmobj.z + thokmobj.height/2) - (mo.z + mo.height/2)) > mo.height then return SKINCOLOR_RED end
					return SKINCOLOR_GREEN
				else
					return SKINCOLOR_RED
				end
			end
			
			local color = checkRange()
			drawCube(mo, color)
			
			if cancelwall then
				B.ResetPlayerProperties(player,false,false)
				player.actiontime = -1
				player.actionstate = 0
				S_StartSound(mo,sfx_s3k7d)
				B.ApplyCooldown(player,TICRATE*3)				
			elseif wallplace then
				player.actionstate = state_placed
				player.actiontime = 0
			end
			return
		elseif player.actionstate == state_placed then
			S_StartSound(mo, sfx_s3kcbs)
			S_StartSound(mo, sfx_cdfm23)
			
			local thokmobj = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			local oldheight = thokmobj.height
			thokmobj.radius = FixedMul(mobjinfo[MT_GEMMAWALL].radius*2, mo.scale)
			thokmobj.height = FixedMul(mobjinfo[MT_GEMMAWALL].height, mo.scale)
			thokmobj.flags2 = $|MF2_DONTDRAW
					
			if P_MobjFlip(mo) == -1
				thokmobj.z = $-(thokmobj.height-oldheight)
			end
					
			thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING
			if P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
				mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
				and thokmobj.z - thokmobj.scale*8 <= mo.z + mo.height
				and thokmobj.z + thokmobj.height + thokmobj.scale*8 >= mo.z
			then
				local foundmobj = 0
				searchBlockmap("objects", function(refmobj, mobj)
					if not (mobj and mobj.valid and mobj.health
						and mobj != mo and mobj.flags&(MF_SHOOTABLE|MF_SOLID))
						or R_PointToDist2(refmobj.x, refmobj.y, mobj.x, mobj.y) > refmobj.radius + mobj.radius
						or refmobj.z - refmobj.scale > mobj.z + mobj.height
						or refmobj.z + refmobj.height + refmobj.scale < mobj.z
						or (mobj and mobj.player and mobj.player.spectator) -- ignore flickies/spectators
					then
						return
					end
							
					foundmobj = mobj
				end, thokmobj)
						
				if foundmobj or abs((thokmobj.z + thokmobj.height/2) - (mo.z + mo.height/2)) > mo.height
					S_StartSound(mo, sfx_s3k8c, player)
				else
					player.gemmarockwall = P_SpawnMobjFromMobj(thokmobj, 0, 0, 0, MT_GEMMAWALL)
					player.gemmarockwall.flags = $|MF_NOCLIPTHING
					player.gemmarockwall.angle = mo.angle
					player.gemmarockwall.target = mo
					player.gemmarockwall.gemmaid = -1
							
					if not (gametyperules & GTR_FRIENDLY)
						player.gemmarockwall.color = player.skincolor
						player.gemmarockwall.colorized = true
					end
							
					B.PayRings(player)
					B.ApplyCooldown(player,TICRATE)
				end
			else
				thokmobj.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
				P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
					mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
					S_StartSound(mo, sfx_s3k8c, player)
			end
			player.actionstate = 0
			player.actiontime = 0
			return
		end
		if player.actionstate
			if player.actiontime <= 0 then
			player.gemmasmash = 0
			// remove current platform replace with another lol
			end
			player.actiontime = $ + 1
			mo.momx = $*7/8
			mo.momy = $*7/8
			-- Rock wave
			if player.actionstate == state_charging
				if player.exhaustmeter < FRACUNIT then
					player.action2text = "Charge "..100*player.exhaustmeter/FRACUNIT.."%"
				end
					
				if player.actiontime == threshold2 then
					S_StartSound(mo,sfx_s1c3)
					for l = 0,8
						P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,256*mo.scale,16,MT_BOXSPARKLE,mo.angle+45*l*ANG1,nil,1)
					end
					player.gemmawave = 1
				end
				if player.actiontime == threshold3 then
					S_StartSound(mo,sfx_s1c3)
					for l = 0,8
						P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,256*mo.scale,16,MT_BOXSPARKLE,mo.angle+45*l*ANG1,nil,1)
					end
					player.gemmawave = 2
				end
					
				player.mo.state = S_PLAY_ROLL
				player.canguard = false
				player.pflags = $|PF_JUMPSTASIS|PF_THOKKED -- rev: PF_THOKKED prevents AbilitySpecial intervention
				player.exhaustmeter = max(0,$-(FRACUNIT/TICRATE/2))
				
				B.DrawAimLine(player,mo.angle)
					
				-- Draw ground range
				-- ?.DrawGroundRange(player, mo.angle)
					
				if not(player.actiontime&3) then
					S_StopSoundByID(mo, sfx_kc38)
					S_StartSound(mo, sfx_kc38)
						
					local ghost = P_SpawnGhostMobj(mo)
					ghost.spritexscale = mo.spritexscale
					ghost.spriteyscale = mo.spriteyscale
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.scalespeed = ghost.scale/16
					ghost.destscale = $*16
				end
					
				-- mr inefficient
				if rockwave then
					player.actionstate = 2--1
					player.chargedtime = player.actiontime
					-- mr inefficient 2
					if player.chargedtime < threshold2 then 
						player.actionstate = 3 
					end
					player.actiontime = 0
					player.exhaustmeter = FRACUNIT
				elseif canceltrigger then
					--B.ResetPlayerProperties(player,false,false)
					player.actionstate = 0
					player.actiontime = -1
					S_StartSound(mo,sfx_s3k7d)
					player.gemmawave = 0 // fix over chargeing wave carring over to the next wave bug?
					B.ApplyCooldown(player,TICRATE*3)
					S_StopSoundByID(mo, sfx_kc38)
					player.exhaustmeter = FRACUNIT
				elseif rolltrigger then
					mo.state = S_PLAY_ROLL
					-- speed thok: use mo.scale ffs
					P_InstaThrust(player.mo, mo.angle, 26*mo.scale) -- Fixed speed thok--(player.actiontime)*FRACUNIT) -- variable speed thok
					player.actionstate = 0
					player.actiontime = 0
					
					S_StopSoundByID(mo, sfx_kc38)
					S_StartSound(mo,sfx_cdfm01)
					player.gemmawave = 0
					B.ApplyCooldown(player,TICRATE*4)
					player.pflags = $|PF_THOKKED
					player.exhaustmeter = FRACUNIT/6
				elseif idletrigger then
					mo.state = S_PLAY_ROLL
					player.actionstate = 0
					player.actiontime = 0
					S_StopSoundByID(mo, sfx_kc38)
					player.gemmawave = 0
					S_StartSound(mo,sfx_s3k7d)
					B.ApplyCooldown(player,TICRATE*3)
					player.pflags = $|PF_THOKKED
					player.exhaustmeter = FRACUNIT
				end
				
				player.drawangle = mo.angle
				player.pflags = ($|PF_JUMPED)&~PF_NOJUMPDAMAGE
				P_SetObjectMomZ(mo,FRACUNIT/2,false) //Rise slowly /2
				
			elseif player.actionstate == 1
				
				mo.momz =  $/2
				player.gemmasmash = 0
				
				if player.actiontime == TICRATE/3
					player.actionstate = 2
					player.actiontime = 0
					player.exhaustmeter = FRACUNIT
					
					P_SetObjectMomZ(mo, 16*FRACUNIT, false) 
					S_StartSound(mo, sfx_kc38)
					S_StartSound(mo, sfx_3db16)
					S_StopSoundByID(mo, sfx_s3kcbs)
				end
			elseif player.actionstate == 2
				player.exhaustmeter = FRACUNIT
				if player.actiontime == TICRATE/3
					player.actionstate = 3
					player.actiontime = 0
					
					S_StartSound(mo, sfx_s3k83)
					S_StopSoundByID(mo, sfx_kc38)
					S_StopSoundByID(mo, sfx_3db16)
				end
			elseif player.actionstate == 3
				S_StopSoundByID(mo, sfx_kc38)
				if P_IsObjectOnGround(mo) or P_IsObjectInGoop(mo)
					player.pflags = $|PF_FULLSTASIS
					player.actionstate = 4
					local hardthr = (player.chargedtime >= threshold2) and 2 or 1 -- effect tumble duration instead?
					player.actiontime = 0
					
					local sfx_intensity = player.chargedtime < threshold2 and sfx_s3kccs or sfx_bexpld
					S_StartSound(mo, sfx_kc40)
					S_StartSound(mo, sfx_intensity)
					S_StopSoundByID(mo, sfx_s3k83)
					
					if player == displayplayer and not splitscreen
						P_StartQuake(8*FRACUNIT, 7)
					end
					
					local wavespd = 32
					local wavblockabule = 1
					if player.gemmawave then
						if player.gemmawave == 1 then wavespd = $*2
						elseif player.gemmawave == 2 then wavespd = $*3
						end
						wavblockabule = 1+player.gemmawave
						player.gemmawave = 0
					end
					for i = 0, 7
						local dirt = P_SpawnMobjFromMobj(mo, 0,0,0, MT_GEMMADIRT)
						P_Thrust(dirt, player.drawangle - ANGLE_45 + (ANGLE_11hh*i), wavespd*mo.scale)
						
						dirt.angle = mo.angle
						dirt.target = mo
						dirt.hit_sound = sfx_hit01
						dirt.blockable = wavblockabule // 1
						dirt.block_stun = 4
						dirt.block_sound = sfx_s3k49
						dirt.block_hthrust = 1
						dirt.block_vthrust = 6*hardthr 
						dirt.flags = $|MF_MISSILE
						
						if not (gametyperules & GTR_FRIENDLY)
							dirt.color = player.skincolor
							dirt.colorized = true
						end
					end
				else
					local momz = player.chargedtime >= threshold2 and -84 or -44
					P_SetObjectMomZ(mo, momz*FRACUNIT, false)
					mo.spritexscale = FRACUNIT*2/3
					mo.spriteyscale = FRACUNIT*3/2
				end
			elseif player.actionstate == 4
				mo.state = S_PLAY_GLIDE_LANDING
				player.pflags = $|PF_FULLSTASIS
				
				local endlag = TICRATE/3--player.chargedtime < threshold2 and TICRATE/2 or TICRATE
				if player.chargedtime >= threshold2 and player.chargedtime < threshold3 then endlag = (TICRATE/2)//+(TICRATE/5)
				elseif player.chargedtime >= threshold3 then endlag = TICRATE*3/4
				end
				
				-- For some reason if you have 0 rings and hit a monitor beforehand this takes the rings away
				if player.actiontime == endlag
					mo.state = S_PLAY_STND
					B.ApplyCooldown(player,TICRATE*3)
					player.actionstate = 0
					player.actiontime = 0
				end
			end
			
			if (player.actionstate and player.actionstate >= 0 and player.actionstate < 4)
				if not P_IsObjectOnGround(mo)
					mo.z = $ + mo.scale*P_MobjFlip(mo)
				end
				player.pflags = $|P_GetJumpFlags(player)
				mo.state = S_PLAY_JUMP
				player.gemmasquish = 4
				
				if player.actionstate > 1 or not (player.actiontime%3)
					local ghost = P_SpawnGhostMobj(mo)
					ghost.spritexscale = mo.spritexscale
					ghost.spriteyscale = mo.spriteyscale
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.scalespeed = ghost.scale/16
					ghost.destscale = $*16
				end
			end
			
		elseif player.actionstate == 0
		and doaction == 1
			if not P_IsObjectOnGround(mo)
				player.actionstate = state_charging--1
				player.actiontime = 0
				B.PayRings(player)
				
				S_StartSound(mo, sfx_s3kcbs)
				S_StartSound(mo, sfx_cdfm23)
				S_StartSound(mo, sfx_s3k9c)
				
				for d = 0, 16
					P_SpawnParaloop(mo.x + mo.momx*4, mo.y + mo.momy*4, mo.z + mo.height/2,
					64*mo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, false)
				end
			elseif player.gemmarockwall and player.gemmarockwall.valid
			and player.gemmarockwall.health and player.gemmarockwall.type == MT_GEMMAWALL
				P_KillMobj(player.gemmarockwall)
			else
				if player.actionstate == 0 then
					player.actionstate = state_placing
					--player.actiontime = 0
					--B.PayRings(player)
					
					--S_StartSound(mo, sfx_s3kcbs)
					--S_StartSound(mo, sfx_cdfm23)
					--S_StartSound(mo, sfx_s3k9c)
				end
				--else
			end
		end
	end
	
	local GemmaCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,angle,thrust,thrust2,collisiontype)
		if not (plr[n1])
			return false
		end
		if not (mo[n1])
			return false
		end
		if (pain[n1])
			return false
		end
		if plr[n1].gemmasmash == 1 and def[n1] > 1 and atk[n2] >= 1 and hurt == 0 then //even with the extra defense uncurle
			mo[n1].momz = $/2
			plr[n1].gemmasmash = 0
			plr[n1].state = S_PLAY_FALL
			local angle = R_PointToAngle2(0,0,mo[n2].momx,mo[n2].momy)
			local recoilthrust = FixedHypot(mo[n2].momx,mo[n2].momy)
			B.DoPlayerFlinch(plr[n1], TICRATE/5, angle, recoilthrust)
			return
		end
		if (atk[n1] > 1) then // we want gemma to kind of pierce threw players she hit with "earth strike"
			if plr[n1].gemmasmash == 1 then
				plr[n1].gemmasmash = 0
				plr[n1].pflags = $&~PF_JUMPED
				plr[n1].state = S_PLAY_ROLL // we want her to commit to strikeing the ground without creating any platforms!
				mo[n1].momz = $*-1
				mo[n2].momx = $*3/2
				mo[n2].momy = $*3/2
				return
			end
			if plr[n1].actionstate == 3 then
				mo[n1].momz = $*-1
				mo[n2].momx = $*2
				mo[n2].momy = $*2
			end
		end
	end
	
	//exhaust is faster if spindashing on the rock platform --JABsphere
		local function GemmaExhaust(player)
			if player.mo.state == S_PLAY_SPRING and player.pflags&PF_JUMPED and player.gemmarocked then // we must off bounced off of something we hit
			player.gemmasmash = 0
			//player.gemmarocked = 2
				if player.gemmarocked == 4 then
					player.exhaustmeter = min(FRACUNIT,$+(FRACUNIT/2))
					player.gemmarocked = 6
				elseif player.gemmarocked == 3 then
					player.pflags = $|PF_THOKKED
					player.exhaustmeter = 0//max(0,$-(FRACUNIT/2))
					player.gemmarocked = 6
				end
			end	
			if player.gemmasmash > 1 then
				if not player.gemmarocked or player.gemmarocked <= 1 then
				player.gemmarocked = 2
				end
				local maxtime = TICRATE*4
				if player.gemmaspindash then
					P_SetObjectMomZ(player.mo, FRACUNIT/-2, true)
					maxtime = TICRATE*7/2
				end
				player.exhaustmeter = max(0,$-(FRACUNIT/maxtime))
				if not player.exhaustmeter
					P_ResetPlayer(player)
					player.gemmaspindash = 0
					player.gemmasmash = 0
					player.actiontime = 0 // just in case...
					player.gemmarocked = 6 // setting this to 6 also makes exhaust recover slower untell she hits the ground
					player.mo.momz = $/3
					player.mo.momx = $/2
					player.mo.momy = $/2
					P_SetObjectMomZ(player.mo, -10*FRACUNIT, true)
					player.mo.state = S_PLAY_FALL
				end
			elseif not (player.gemmasmash) and (player.actiontime <= 1) and (player.mo.state != S_PLAY_PAIN) then
				local mintime = TICRATE*8
				if P_IsObjectOnGround(player.mo) then
				player.gemmarocked = 0
				end
				if player.actiontime == 1 then
				player.exhaustmeter = FRACUNIT
				else
				if player.gemmarocked and player.gemmarocked == 6 then
					mintime = TICRATE*20
				end
				player.exhaustmeter = min(FRACUNIT,$+(FRACUNIT/mintime)) // cooldown exhast
				end
			elseif (player.mo.state == S_PLAY_PAIN) then
				player.gemmaspindash = 0
				player.gemmasmash = 0
			end
			return true
		end
	
	//Stats
	B.SkinVars["gemma"] = {
		special = GemmaBattle,
		func_priority_ext = GarbagePriority7,
		func_postcollide = GemmaCollide,
		func_exhaust = GemmaExhaust
	}
end)

//Wall thinker
addHook("MobjThinker", function(mobj)
	if (gamestate ~= GS_LEVEL) then return end
	if not mobj.gemmaid then return end
	
	if mobj.gemmaid > 0
		if not (mobj.tracer and mobj.tracer.valid and mobj.tracer.health)
		then P_RemoveMobj(mobj) return end
		mobj.scale = mobj.tracer.scale
		mobj.color = mobj.tracer.color
		mobj.colorized = mobj.tracer.colorized
		mobj.frame = 3-mobj.tracer.health
		mobj.blendmode = mobj.tracer.blendmode
		mobj.flags2 = mobj.tracer.flags2
		mobj.eflags = mobj.tracer.eflags
		mobj.target = mobj.tracer.target
		
		if mobj.gemmaid >= 5
			local zoffset = FixedMul(mobj.tracer.spriteyscale, mobj.tracer.height)*P_MobjFlip(mobj)
			local negative = mobj.gemmaid > 5 and -1 or 1
			mobj.angle = mobj.tracer.angle
			
			if mobj.gemmaid >= 7
				zoffset = 0
				mobj.state = S_INVISIBLE
			else
				if P_MobjFlip(mobj) == -1
					zoffset = $ + mobj.tracer.height
				end
				mobj.frame = $+3
			end
			
			P_MoveOrigin(mobj,
			mobj.tracer.x + P_ReturnThrustX(nil, mobj.angle - ANGLE_90, mobj.radius*negative),
			mobj.tracer.y + P_ReturnThrustY(nil, mobj.angle - ANGLE_90, mobj.radius*negative),
			mobj.tracer.z + zoffset)
		else
			local anglemove = ANGLE_90
			local dist = mobj.radius
			mobj.angle = mobj.tracer.angle + ANGLE_90 * (mobj.gemmaid-1)
			mobj.spriteyscale = mobj.tracer.spriteyscale
			
			if not (mobj.gemmaid % 2)
				//dist = $
				anglemove =  ANGLE_180// 90
				if mobj.wallclone then
				anglemove = 0
				end
			else
				dist = $*2
			end
			
			P_MoveOrigin(mobj,
			mobj.tracer.x + P_ReturnThrustX(nil, mobj.angle - anglemove, dist),
			mobj.tracer.y + P_ReturnThrustY(nil, mobj.angle - anglemove, dist),
			mobj.tracer.z)
			if not (mobj.gemmaid % 2) then // we are moveing this again because I dont know what Im doing lol --JABsphere
				P_MoveOrigin(mobj,
				mobj.x + P_ReturnThrustX(nil, mobj.angle - ANGLE_90, dist),
				mobj.y + P_ReturnThrustY(nil, mobj.angle - ANGLE_90, dist),
				mobj.tracer.z)
			end
		end
	elseif not mobj.cusval
		for i=1,8 
			local wall = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_GEMMAWALL)
			wall.target = mobj.target
			wall.tracer = mobj
			wall.sprite = SPR_EWAL
			wall.gemmaid = i
			wall.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY
			
			if wall.gemmaid >= 7
				wall.state = S_INVISIBLE
				wall.angle = mobj.angle
			elseif wall.gemmaid >= 5
				wall.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD
				wall.frame = $+3
				wall.height = wall.scale
				wall.angle = mobj.angle
			else
				if not (i % 2) // this is the long side of the wall
					//wall.spritexscale = FRACUNIT*2
					//wall.radius = $*2
					wall.positionoffset = 2
					// we are makeing a clone of this wall  -- JABSphere
					local wall2 =  P_SpawnMobjFromMobj(mobj, 0,0,0, MT_GEMMAWALL)
					wall2.target = mobj.target
					wall2.tracer = mobj
					wall2.sprite = SPR_EWAL
					wall2.gemmaid = i
					wall2.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					wall2.positionoffset = 2
					wall2.wallclone = true
					wall2.renderflags = $|RF_PAPERSPRITE
					wall2.flags = $|MF_PAPERCOLLISION
					wall2.angle = mobj.angle + ANGLE_90 * (i-1)
				end
			
				wall.renderflags = $|RF_PAPERSPRITE
				wall.flags = $|MF_PAPERCOLLISION
				wall.angle = mobj.angle + ANGLE_90 * (i-1)
			end
		end
		
		for i = -4, 4
			for d = -4, 4
				local dust = P_SpawnMobjFromMobj(mobj,
				P_ReturnThrustX(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustX(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				P_ReturnThrustY(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustY(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				0, MT_TNTDUST)
			end
		end
		
		S_StartSound(mobj, mobj.info.seesound)
		mobj.spriteyscale = FRACUNIT/16
		mobj.cusval = 1
	elseif mobj.spriteyscale < FRACUNIT
		mobj.spriteyscale = min($ + FRACUNIT/16, FRACUNIT)
	elseif mobj.fuse % 2
		mobj.flags2 = $|MF2_SHADOW
	else
		mobj.flags2 = $&~MF2_SHADOW
	end
	if mobj.gemmaid > 0 and mobj.tracer.health > 1 and not (mobj.renderflags&RF_FLOORSPRITE) and not mobj.tracer.fuse 
	and (P_MobjTouchingSectorSpecialFlag(mobj, SSF_REDTEAMBASE)or P_MobjTouchingSectorSpecialFlag(mobj, SSF_BLUETEAMBASE)) then
		P_DamageMobj(mobj.tracer, mobj, mobj, 1, 0) // take damage over time if in a ctf base
		mobj.tracer.fuse = TICRATE*2
	end
	if mobj.tracer then return end
	if (not mobj.target and not mobj.target.valid) or (mobj.target.player.deadtimer) then // probably shouldn't be messing with this -JABsphere
	mobj.gemmaid = 0
	P_KillMobj(mobj) // if gemmas dead you die too
	end
end, MT_GEMMAWALL)

-- Walls causing resync (bacause solid flagged paper colisions do not like fps dropes of any kind -- JABsphere)
//No colliding the wall with itself
-- rev: not sure about this one..
addHook("MobjCollide", function(thing, tmthing)
	if (gamestate ~= GS_LEVEL) then return end
	if thing and thing.valid and tmthing and tmthing.valid
	and tmthing.type == MT_GEMMAWALL
		return false
	end
end, MT_GEMMAWALL)

-- rev: Allow same-team members/you to walk through your walls
addHook("MobjCollide", function(thing, tmthing)
	if (gamestate ~= GS_LEVEL) then return end
	if tmthing and tmthing.valid and thing and thing.valid and (thing.renderflags&RF_FLOORSPRITE) and (
		(tmthing.z < thing.z and P_MobjFlip(thing) > 0) or (tmthing.z > thing.z and P_MobjFlip(thing) < 0) ) then
		return false
	end
	if 	thing and thing.valid and not (thing.renderflags&RF_FLOORSPRITE) and
		(	(
		G_GametypeHasTeams()
		and tmthing and tmthing.valid and tmthing.player
		and thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z
		and tmthing.player and thing.target.player.ctfteam == tmthing.player.ctfteam
			) or thing.target == tmthing )
	then
		local allowpass = true
		return false
		
	end
	if allowpass then return end 
	if not tmthing.player then return end 
	if (thing.renderflags&RF_FLOORSPRITE) then return end 
	if thing.z - thing.scale <= tmthing.z + tmthing.height -FRACUNIT
	and thing.z + thing.height + thing.scale >= tmthing.z + FRACUNIT
	then //soild paper collision causees reyncs so we push players away instead
			local pushangle = R_PointToAngle2(thing.tracer.x, thing.tracer.y, tmthing.x, tmthing.y) // we use the walls source for most calculations
			local puherspeed = (FixedHypot(tmthing.momx,tmthing.momy)/2) 
			local walldistance = R_PointToDist2(thing.tracer.x, thing.tracer.y, tmthing.x, tmthing.y) //FRACUNIT
			if  not (thing.gemmaid % 2) then // if we are touching the "long" sides of the wall set postion
				local xdistance = thing.tracer.x+FixedMul(walldistance*6/5, cos(pushangle))
				local ydistance = thing.tracer.y+FixedMul(walldistance*6/5, sin(pushangle))
				local xydistance = R_PointToDist2(thing.tracer.x, thing.tracer.y, xdistance, ydistance)
				if xydistance < walldistance*2 then
				local xdiff = tmthing.x - xdistance
				local ydiff = tmthing.y - ydistance
				tmthing.momx = xdiff/-2
				tmthing.momy = ydiff/-2
				else
				tmthing.momx = $/-2
				tmthing.momy = $/-2
				end
			else
				P_InstaThrust(tmthing, pushangle, (puherspeed/2)+(walldistance/45))
			end
			P_Thrust(tmthing, pushangle, (puherspeed/3)+(walldistance/45))
		return false
	end
end, MT_GEMMAWALL)

//Are we able to damage the wall? Should we transfer the damage to the object source?
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if (gamestate ~= GS_LEVEL) then return end
	if not target.fuse and target.target != inflictor
	and target.target != source and not (G_GametypeHasTeams() and target.target
	and target.target.valid and target.target.player and source and source.valid
	and source.player and target.target.player.ctfteam == source.player.ctfteam)
		if target.gemmaid > 0
			if target.tracer and target.tracer.valid
			and not target.tracer.fuse
				if inflictor and inflictor.valid
					S_StartSound(inflictor, target.info.painsound)
				end
				P_DamageMobj(target.tracer, inflictor, source, damage, damagetype)
			end
			return false
		end
		target.fuse = TICRATE
	else
		return false
	end
end, MT_GEMMAWALL)

-- rev: TODO -> weird resynch issue when another player runs into a wall?
//Wall collision for damage
addHook("MobjCollide", function(thing, tmthing)
	if (gamestate ~= GS_LEVEL) then return end
	if thing and thing.valid and not (thing.renderflags&RF_FLOORSPRITE)
		and tmthing and tmthing.valid and tmthing.player
		and tmthing.player.battle_atk and not thing.fuse
		and thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z
		and thing.target != tmthing and not (G_GametypeHasTeams() and thing.target
		and thing.target.valid and thing.target.player
		and tmthing.player and thing.target.player.ctfteam == tmthing.player.ctfteam)
	then
		if thing.gemmaid > 0
			if thing.tracer and thing.tracer.valid and not thing.tracer.fuse
				P_DamageMobj(thing.tracer, tmthing, tmthing, 1, 0)
				if tmthing and tmthing.valid
					local angle = thing.flags & MF_PAPERCOLLISION and thing.angle - ANGLE_90 or R_PointToAngle2(thing.x, thing.y, tmthing.x, tmthing.y)
					S_StartSound(tmthing, thing.info.painsound)
					P_InstaThrust(tmthing, angle, max(tmthing.player.speed, 24*thing.scale))
					tmthing.momz = -$
					tmthing.flags = $|MF_NOCLIPTHING
					P_TryMove(tmthing, tmthing.x + tmthing.momx, tmthing.y + tmthing.momy, true)
					tmthing.z = $ + tmthing.momz
					tmthing.flags = $&~MF_NOCLIPTHING
				end
			end
			return true
			--return false
		else
			P_DamageMobj(thing, tmthing, tmthing, 1, 0)
		end
	end
end, MT_GEMMAWALL)

//Dumb Debris
addHook("MobjFuse", function(mobj) return true end, MT_GEMMAWALL)
addHook("MobjDeath", function(mobj)
	if (gamestate ~= GS_LEVEL) then return end
	if mobj.tracer and mobj.tracer.type == MT_GEMMAWALL return end
	S_StartSound(mobj, mobj.info.deathsound)
	mobj.health = 0
	mobj.tics = TICRATE*2
	mobj.flags = $|MF_NOCLIP
	mobj.gemmaid = 0
	for z = 0, 4
		for i = -4, 4
			for d = -4, 4
				local rock = P_SpawnMobjFromMobj(mobj,
				P_ReturnThrustX(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustX(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				P_ReturnThrustY(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustY(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				mobj.info.height - (mobj.info.height/4*z), MT_ROCKCRUMBLE1)
				if rock and rock.valid
					rock.color = mobj.color
					rock.colorized = mobj.colorized
					rock.flags2 = $&~MF2_OBJECTFLIP
					rock.eflags = $&~MFE_VERTICALFLIP
					rock.fuse = TICRATE*5
					rock.shrink = true -- rev: dumb problems need dumb solutions
				end
			end
		end
	end
	return true
end, MT_GEMMAWALL)

-- rev: dumb problems need dumb solutions
addHook("MobjThinker", function(rock)
	if rock.shrink then
		rock.scale = $-1500
		rock.shadowscale = rock.scale
		if rock.scale <= TICRATE then P_RemoveMobj(rock) end
	end
end, MT_ROCKCRUMBLE1)

//Dirt stuff
addHook("MobjThinker", function(mobj)
	if not P_IsObjectOnGround(mobj)
		mobj.momz = $ + P_GetMobjGravity(mobj)*7
	elseif leveltime%2 and mobj.state != mobj.info.painstate
		local ngangle = FixedAngle(((leveltime * 42) % 360) << FRACBITS)
		local xofs = sin(ngangle) * (mobj.radius>>FRACBITS) + FixedDiv(mobj.momx*2, mobj.scale)
		local yofs = cos(ngangle) * (mobj.radius>>FRACBITS) + FixedDiv(mobj.momy*2, mobj.scale)

		local spark = P_SpawnMobjFromMobj(mobj, xofs, yofs, 0, MT_BOXSPARKLE)
		spark.fuse = 12
		spark.momz = mobj.height/spark.fuse*P_MobjFlip(mobj)
		spark.momx = mobj.momx/8
		spark.momy = mobj.momy/8
	end
	if mobj.state == mobj.info.painstate
		mobj.spriteyscale = min(abs(TICRATE*2 - mobj.tics) * FRACUNIT/(TICRATE/8), FRACUNIT)
		if mobj.tics == 1
			for i=0, 2
				//local ghost = P_SpawnGhostMobj(mobj)
				local ghost = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GHOST)
				if i == 1
					S_StartSound(ghost, mobj.info.deathsound)
				end
				ghost.scale = mobj.scale
				ghost.fuse = TICRATE
				ghost.state = mobj.state
				ghost.flags = $&~MF_NOGRAVITY
				ghost.flags2 = mobj.flags2&MF2_OBJECTFLIP
				ghost.eflags = mobj.eflags&MFE_VERTICALFLIP
				P_SetObjectMomZ(ghost, 6*FRACUNIT, false) 
				if mobj.target and mobj.target.valid and mobj.target.player
					P_InstaThrust(ghost, (i*-ANGLE_90)+(mobj.target.player.cmd.angleturn<<16)+ANGLE_90, 4*mobj.scale)
				else
					P_InstaThrust(ghost, P_RandomKey(ANGLE_MAX), 4*mobj.scale)
				end
				ghost.sprite = SPR_EWAL
				ghost.frame = H+i
			end
		end
	else
		//local ghost = P_SpawnGhostMobj(mobj)
		local ghost = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_THOK)
		ghost.destscale = ghost.scale*4
		ghost.fuse = TICRATE/3
		ghost.scale = mobj.scale
		ghost.sprite = mobj.sprite
		ghost.frame =  mobj.frame
		ghost.frame = $|TR_TRANS50 
		
		if mobj.state >= S_MINUSDIRT1 and mobj.state <= S_MINUSDIRT7
			mobj.tics = min($, 4)
		end
	end
	if mobj.target and mobj.target.valid
		mobj.flags = $|MF_MISSILE&~MF_NOCLIPTHING&~MF_NOGRAVITY
		mobj.health = mobj.info.spawnhealth
	end
end, MT_GEMMADIRT)

local dirtriseing = function(mobj) // made this a funtion for my convenience - JABsphere

	mobj.state = mobj.info.painstate
	mobj.spriteyscale = min(abs(TICRATE*2 - mobj.tics) * mobj.scale/(TICRATE/8), mobj.scale)
	mobj.momx = 0
	mobj.momy = 0
	mobj.threshold = 1
	mobj.flags = $|MF_NOCLIPTHING

end

local dirtrise = function(target, mobj)
	if (gamestate ~= GS_LEVEL) then return end
	if mobj and mobj.valid and mobj.type == MT_GEMMADIRT
	and not mobj.threshold and mobj.state != mobj.info.painstate
		dirtriseing(mobj) 
		
		if target and target.valid
			mobj.flags = $&~MF_MISSILE
			P_MoveOrigin(mobj, target.x, target.y, mobj.z)
			mobj.flags = $|MF_MISSILE
		end
	end
end

addHook("ShouldDamage", function(target, mobj)
	if (gamestate ~= GS_LEVEL) then return end
	if mobj and mobj.valid and mobj.type == MT_GEMMADIRT
	and (not P_IsObjectOnGround(mobj) or not (target and target.valid and P_IsObjectOnGround(target)))
		return false
	end
end)

-- rev: Gemmadirt -> team mode: don't give rings to teammates.
local function nogmdirt_pain(targ, mo, src)
	if (gamestate ~= GS_LEVEL) then return end
	if  targ and targ.player and mo and mo.type == MT_GEMMADIRT and mo.target and mo.target.player 
		and G_GametypeHasTeams() and targ.player.ctfteam == mo.target.player.ctfteam 
	then
		return false
	else
		-- rev: Gemmadirt -> cause collision to lift player into the air if touching ground (only for ground, not air!!)
		-- note: only momentum things // and tumble JABEsphere
		if CBW_Battle and targ and targ.player and mo and mo.type == MT_GEMMADIRT and src and src.player then
			local B = CBW_Battle
			local vulnerable = B.PlayerCanBeDamaged(targ.player)
			local vthrust = mo.block_vthrust
			local rspeed = (P_AproxDistance(mo.momx, mo.momy))/FRACUNIT
			local targspeed = (P_AproxDistance(targ.momx, targ.momy))/FRACUNIT
			
			if targ.pushtics then // we dont want multibule dirts to damage the player at once
			if not targ.player.powers[pw_flashing] then
			targ.player.powers[pw_flashing] = 1
			end
			targ.pushtics = 1 
			targ.pushed = src
			B.PlayerCreditPusher(targ.player,src)
			return false end
			if targ.state == S_PLAY_PAIN  and targspeed >= rspeed  then return false end
			if targ.player.guard > 0 then return end 
			
			if vulnerable and targ.player.battle_def >= mo.blockable then
				if targ.player.battle_def == mo.blockable and P_IsObjectOnGround(targ) then
					targ.momz = $/2
					B.ZLaunch(targ, src.scale*vthrust, true)
				end
				local setangle = R_PointToAngle2(src.x, src.y, mo.x, mo.y)
				if not targ.player.powers[pw_flashing] then
				targ.player.powers[pw_flashing] = 1
				end
				targ.pushtics = 1
				B.DoPlayerTumble(targ.player, 15+rspeed, setangle, mo.scale*5, true)
				targ.pushed = src
				B.PlayerCreditPusher(targ.player,src)
				dirtriseing(mo)
				if targ and targ.valid
					mo.flags = $|MF_NOCLIPTHING
					mo.flags = $&~MF_MISSILE
					P_MoveOrigin(mo, targ.x, targ.y, mo.z)
				end
			return false
			elseif vulnerable then -- Defense of target higher than mo.blockable, so reduced knockback
				B.ZLaunch(targ, src.scale*vthrust / 3, true)
			end
			return
		end
	end
end

addHook("ShouldDamage", nogmdirt_pain)
addHook("MobjCollide", nogmdirt_pain)

addHook("MobjDeath", function(mo, inf, source, damage, damagetype) // we want to make sure the platform stays intact when she uses rock wave
	if (gamestate ~= GS_LEVEL) then return end
	if not mo.valid return end
	if not mo.tracer return end
	if mo.tracer.valid and mo.tracer.skin == "gemma" and mo.tracer.player then
		if mo.z > mo.tracer.z+(100*mo.scale) or mo.z < mo.tracer.z-(100*mo.scale) then // too far
		mo.fallplatform = true
		return end
		
		if (not inf and mo.tracer.player.actionstate and not mo.fallplatform) then // to do: prevent death effect form triggering twice
			mo.momx = $/2
			mo.momy = $/2
			P_SetObjectMomZ(mo, 1*-FRACUNIT, true)
			mo.fallplatform = true
			mo.health = 1000
			mo.state = S_SPAWNSTATE
			mo.sprite = SPR_BLDR
			mo.flags = $|MF_MISSILE
			mo.frame = 0
			return true
		end

	end
end,MT_GEMMAPLAT)

addHook("MobjSpawn", function(mo) // set projectile stats just in case...
	local B = CBW_Battle
	if B and mo then 
	mo.loadorderfix = true
	mo.blockable = 1
	mo.block_stun = 3
	mo.block_sound = sfx_s3k49
	mo.block_hthrust = 6
	mo.block_vthrust = 2
	end
end,MT_GEMMAPLAT)

addHook("MobjSpawn", function(mo)
	local B = CBW_Battle
	if B and mo then 
		mo.loadorderfix = true
		mo.block_stun = 4
		mo.block_sound = sfx_s3k49
		mo.block_hthrust = 3
		mo.block_vthrust = 1
		if not mo.blockable then
			mo.blockable = 1
		end
	end
end,MT_GROCK)

addHook("ShouldDamage", function(pmo, inflictor, source, damage, damagetype) // rock platform tumbles if it hits someone with no defense
	local B = CBW_Battle
	if not B then return end
	if not inflictor or not inflictor.valid then return end
	if inflictor.type != MT_GEMMAPLAT and inflictor.type != MT_GROCK then return end
	if not source return false end
	if pmo.player and not inflictor.loadorderfix then return false end
	if  pmo.player and pmo.state == S_PLAY_PAIN then return end // let rock platform damage players if there already in tumble
	if pmo.player and source and source.valid and source.player and not(B.MyTeam(source.player,pmo.player)) and not P_PlayerInPain(pmo.player) then
		local vulnerable = B.PlayerCanBeDamaged(pmo.player)

		if pmo.player.guard > 0 then 
		source.player.gemmarocked = 3
		return end
		if source.player.gemmarocked and source.player.gemmarocked <= 2 then
		source.player.gemmarocked = 4 // 4 is increase
		end
		if inflictor.valid and vulnerable and pmo.player.battle_def < inflictor.blockable then
			pmo.pushtics = 1  
			local pushangle = R_PointToAngle2(source.x, source.y, pmo.x, pmo.y)
			B.DoPlayerTumble(pmo.player, 31, pushangle, inflictor.scale*5, true)
			pmo.player.powers[pw_flashing] = 1
			P_SetObjectMomZ(pmo, 4*FRACUNIT, true) // we need this otherwise she will lose credit
			pmo.pushed = source
			B.PlayerCreditPusher(pmo.player,source)
			inflictor.flags = $&~MF_MISSILE
			return false
		end
	end
end,MT_PLAYER)

addHook("PlayerThink", function(player)
	if player.pushed_creditplr and player.pushed_creditplr.valid 
	and player.pushed_creditplr.mo.skin == "gemma" and player.pushed_creditplr.gemmarocked
	and player.pushed_creditplr.gemmarocked <= 2 and player.state != S_PLAY_PAIN then
		player.pushed_creditplr.gemmarocked = 3 // 3 is decrease
	end
end,MT_PLAYER)

addHook("MobjDamage", dirtrise) // the code for dirtrise is still here I just moved it up a bit -JABsphere
addHook("MobjDeath", dirtrise)